var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { defineComponent, useCssVars, openBlock, createElementBlock, renderSlot, ref, reactive, computed, onMounted, normalizeStyle, unref, createElementVNode, normalizeClass } from "vue";
var Timeline_vue_vue_type_style_index_0_lang = "";
const _hoisted_1 = { class: "timeline" };
const __default__$2 = defineComponent({
  name: "Timeline"
});
const _sfc_main$2 = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$2), {
  props: {
    theme: { type: String, required: false, default: "#dbdde0" },
    background: { type: String, required: false, default: "#fff" }
  },
  setup(__props) {
    useCssVars((_ctx) => ({
      "7697135b-theme": __props.theme,
      "7697135b-background": __props.background
    }));
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("ul", _hoisted_1, [
        renderSlot(_ctx.$slots, "default")
      ]);
    };
  }
}));
const useInit = (props) => {
  const othersRef = ref();
  const slotOthers = ref(false);
  const iconSizeData = reactive({
    small: {
      top: ".28em",
      left: "-34px",
      width: "10px",
      height: "10px"
    },
    medium: {
      top: "0em",
      left: "-39.5px",
      height: "20px",
      width: "20px"
    },
    large: {
      top: "-0.5em",
      left: "-44px",
      height: "30px",
      width: "30px"
    }
  });
  const circleStyle = computed(() => {
    if (!props.bgColor && !props.lineColor && !props.hollow && !props.iconSize)
      return;
    let style = {};
    if (props.bgColor) {
      style = {
        "border-color": props.bgColor,
        "background-color": props.bgColor
      };
    }
    if (props.lineColor)
      style["border-color"] = props.lineColor;
    if (iconSizeData[props.iconSize])
      style = Object.assign({}, style, iconSizeData[props.iconSize]);
    return style;
  });
  const itemStyle = computed(() => {
    return {
      color: props.fontColor
    };
  });
  const slotClass = computed(() => {
    let className = "";
    slotOthers.value && (className = "timeline-others");
    props.hollow && (className = "hollow");
    return className;
  });
  onMounted(() => {
    slotOthers.value = !!othersRef.value.innerHTML;
  });
  return { circleStyle, itemStyle, slotClass, othersRef };
};
const __default__$1 = defineComponent({
  name: "TimelineItem"
});
const _sfc_main$1 = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$1), {
  props: {
    bgColor: { type: String, required: false },
    lineColor: { type: String, required: false },
    hollow: { type: Boolean, required: false, default: false },
    iconSize: { type: String, required: false },
    fontColor: { type: String, required: false, default: "#37414a" }
  },
  setup(__props) {
    const props = __props;
    const { slotClass, circleStyle, itemStyle, othersRef } = useInit(props);
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("li", {
        style: normalizeStyle(unref(itemStyle)),
        class: "timeline-item"
      }, [
        createElementVNode("div", {
          ref_key: "othersRef",
          ref: othersRef,
          style: normalizeStyle(unref(circleStyle)),
          class: normalizeClass([unref(slotClass), "timeline-circle"])
        }, [
          renderSlot(_ctx.$slots, "others")
        ], 6),
        renderSlot(_ctx.$slots, "default")
      ], 4);
    };
  }
}));
const __default__ = defineComponent({
  name: "TimelineTitle"
});
const _sfc_main = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__), {
  props: {
    bgColor: { type: String, required: false },
    lineColor: { type: String, required: false },
    hollow: { type: Boolean, required: false, default: false },
    iconSize: { type: String, required: false },
    fontColor: { type: String, required: false, default: "#37414a" }
  },
  setup(__props) {
    const props = __props;
    const { slotClass, circleStyle, itemStyle, othersRef } = useInit(props);
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("li", {
        style: normalizeStyle(unref(itemStyle)),
        class: "timeline-title"
      }, [
        createElementVNode("div", {
          ref_key: "othersRef",
          ref: othersRef,
          style: normalizeStyle(unref(circleStyle)),
          class: normalizeClass([unref(slotClass), "timeline-circle timeline-title-circle"])
        }, [
          renderSlot(_ctx.$slots, "others")
        ], 6),
        renderSlot(_ctx.$slots, "default")
      ], 4);
    };
  }
}));
const plugin = {
  install(app) {
    app.component(_sfc_main$2.name, _sfc_main$2);
    app.component(_sfc_main.name, _sfc_main);
    app.component(_sfc_main$1.name, _sfc_main$1);
  }
};
export { _sfc_main$2 as Timeline, _sfc_main$1 as TimelineItem, _sfc_main as TimelineTitle, plugin };
